import c4d
from c4d import gui
# Welcome to the world of Python


# Script state in the menu or the command palette
# Return True or c4d.CMD_ENABLED to enable, False or 0 to disable
# Alternatively return c4d.CMD_ENABLED|c4d.CMD_VALUE to enable and check/mark
#def state():
#    return True

# Main function
def main():


    python=c4d.BaseObject(1023866)
    python[c4d.ID_BASELIST_NAME]="Arc"


    bc=c4d.GetCustomDataTypeDefault(c4d.DTYPE_REAL)
    bc[c4d.DESC_UNIT]=c4d.DESC_UNIT_METER
    bc[c4d.DESC_NAME]="Width"
    bc[c4d.DESC_MIN]=0
    addo=python.AddUserData(bc)
    python[addo]=100

    bc=c4d.GetCustomDataTypeDefault(c4d.DTYPE_REAL)
    bc[c4d.DESC_UNIT]=c4d.DESC_UNIT_METER
    bc[c4d.DESC_NAME]="Height"
    bc[c4d.DESC_MIN]=0
    addo=python.AddUserData(bc)
    python[addo]=200

    bc=c4d.GetCustomDataTypeDefault(c4d.DTYPE_LONG)
    bc[c4d.DESC_NAME]="Arch-SubD"
    bc[c4d.DESC_MIN]=1
    addo=python.AddUserData(bc)
    python[addo]=7

    bc=c4d.GetCustomDataTypeDefault(c4d.DTYPE_BOOL)
    #bc[c4d.DESC_UNIT]=c4d.DESC_UNIT_METER
    bc[c4d.DESC_NAME]="Closed"
    addo=python.AddUserData(bc)
    python[addo]=True

    
    bc=c4d.GetCustomDataTypeDefault(c4d.DTYPE_LONG)
    bc[c4d.DESC_NAME]="Intermediate Points"
    bc[c4d.DESC_CUSTOMGUI]=200000281 #Quicktab Radio access
    cycle = c4d.BaseContainer()
    cycle[0] = "None"
    cycle[1] = ""    
    cycle[2] = "Uniform"
    bc[c4d.DESC_CYCLE] = cycle
    DISTRIBUTION=python.AddUserData(bc)
    python[DISTRIBUTION]=0
    
    bc=c4d.GetCustomDataTypeDefault(c4d.DTYPE_LONG)
    bc[c4d.DESC_NAME]="Number"
    bc[c4d.DESC_MIN]=2
    NUMBER=python.AddUserData(bc)
    python[NUMBER]=2



    python[c4d.OPYTHON_CODE]='''



import c4d
#Welcome to the world of Python


def main():

    arcSub=0
    distribution = op[c4d.ID_USERDATA,5]
    number = op[c4d.ID_USERDATA,6]

    null=c4d.BaseObject(c4d.Onull)
    width=op[c4d.ID_USERDATA,1]
    height=op[c4d.ID_USERDATA,2]
    if width>=height*2:
        op[c4d.ID_USERDATA,1]=height*2
        width=op[c4d.ID_USERDATA,1]
    if height*2<=width:
        op[c4d.ID_USERDATA,2]=width/2
        height=op[c4d.ID_USERDATA,2]
    #elif height*2<=width:
        #height=width/2
    if width>=0:
        arcH=width/2#op[c4d.ID_USERDATA,3]
    else:
        arcH=-(width/2)


    if op[c4d.ID_USERDATA,3]==1:
        arcSub=1
    else:
        arcSub=op[c4d.ID_USERDATA,3]*2+1-2

    #


    sClosed=op[c4d.ID_USERDATA,4]
    heightP=height-arcH
    height=height+arcH


    pos=op.GetRelPos()
    angle=c4d.utils.DegToRad(180)
    radius=width/2#width/2+arcH/2

    #SubD Pos Calcualtion================
    angleSubD=0#=angle/arcSub   #angle divider
    posSubpoints=[]

    for i in range(0,arcSub): #Position Calcualtion of Arc
        angleSubD=angleSubD+angle/(arcSub+1)
        y=c4d.utils.SinCos(angleSubD)[0]*(radius)+heightP+arcH
        x=c4d.utils.SinCos(angleSubD)[1]*(radius)
        posSubpoints.append(c4d.Vector(x,y-width/2,0))


    #Spline Creation================
    spline=c4d.SplineObject(4+arcSub,0)
    spline[c4d.SPLINEOBJECT_CLOSED]=sClosed
    spline[c4d.ID_BASELIST_NAME]="Arc"
    #==================================

    pointCount=spline.GetPointCount()


    spline.SetPoint(0,c4d.Vector(width/2,0,0))
    spline.SetPoint(1,c4d.Vector(width/2,heightP,0))
    spline.SetPoint(pointCount-2,c4d.Vector(-width/2,heightP,0))
    spline.SetPoint(pointCount-1,c4d.Vector(-width/2,0,0))

    for i in range(2,pointCount-2):
        spline.SetPoint(i,posSubpoints[i-2])


    spline[c4d.SPLINEOBJECT_INTERPOLATION] = distribution
    spline[c4d.SPLINEOBJECT_SUB] = number

    spline.InsertUnder(null)


    return null











'''
    doc.InsertObject(python)
    doc.SetActiveObject(python)
    c4d.EventAdd()




# Execute main()
if __name__=='__main__':
    main()